<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC Generator (erpcgen): erpcgen::AstWalker Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC Generator (erpcgen)
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classerpcgen_1_1_ast_walker.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classerpcgen_1_1_ast_walker-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">erpcgen::AstWalker Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Performs a depth-first walk of an AST.  
 <a href="classerpcgen_1_1_ast_walker.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_ast_walker_8h_source.html">AstWalker.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for erpcgen::AstWalker:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classerpcgen_1_1_ast_walker.png" usemap="#erpcgen::AstWalker_map" alt=""/>
  <map id="erpcgen::AstWalker_map" name="erpcgen::AstWalker_map">
<area href="classerpcgen_1_1_symbol_scanner.html" title="Scans for symbol names. " alt="erpcgen::SymbolScanner" shape="rect" coords="0,56,154,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:structerpcgen_1_1_ast_walker_1_1bottom__up"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a></td></tr>
<tr class="memdesc:structerpcgen_1_1_ast_walker_1_1bottom__up"><td class="mdescLeft">&#160;</td><td class="mdescRight">Specifier type to select bottom-up handler using ADL.  <a href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">More...</a><br /></td></tr>
<tr class="separator:structerpcgen_1_1_ast_walker_1_1bottom__up"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:structerpcgen_1_1_ast_walker_1_1top__down"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a></td></tr>
<tr class="memdesc:structerpcgen_1_1_ast_walker_1_1top__down"><td class="mdescLeft">&#160;</td><td class="mdescRight">Specifier type to select top-down handler using ADL.  <a href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">More...</a><br /></td></tr>
<tr class="separator:structerpcgen_1_1_ast_walker_1_1top__down"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a478a86ebd3a194c9b36898812c15bc61"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a478a86ebd3a194c9b36898812c15bc61"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#a478a86ebd3a194c9b36898812c15bc61">AstWalker</a> ()=default</td></tr>
<tr class="memdesc:a478a86ebd3a194c9b36898812c15bc61"><td class="mdescLeft">&#160;</td><td class="mdescRight">default constructor <br /></td></tr>
<tr class="separator:a478a86ebd3a194c9b36898812c15bc61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae64501f99560846a44989ca8e02283f6"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#ae64501f99560846a44989ca8e02283f6">AstWalker</a> (std::string inputFile)</td></tr>
<tr class="memdesc:ae64501f99560846a44989ca8e02283f6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#ae64501f99560846a44989ca8e02283f6">More...</a><br /></td></tr>
<tr class="separator:ae64501f99560846a44989ca8e02283f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a044afaa6e4984fb4d161fc13b95ec959"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a044afaa6e4984fb4d161fc13b95ec959"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#a044afaa6e4984fb4d161fc13b95ec959">~AstWalker</a> ()=default</td></tr>
<tr class="memdesc:a044afaa6e4984fb4d161fc13b95ec959"><td class="mdescLeft">&#160;</td><td class="mdescRight">destructor <br /></td></tr>
<tr class="separator:a044afaa6e4984fb4d161fc13b95ec959"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b4e46fd87bbb3cfb655fcd4fb8c2c24"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#a8b4e46fd87bbb3cfb655fcd4fb8c2c24">walk</a> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node)</td></tr>
<tr class="memdesc:a8b4e46fd87bbb3cfb655fcd4fb8c2c24"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function walk the <a class="el" href="classerpcgen_1_1_ast_node.html" title="Homogeneous AST node class. ">AstNode</a> depth-first and invoke handler methods.  <a href="#a8b4e46fd87bbb3cfb655fcd4fb8c2c24">More...</a><br /></td></tr>
<tr class="separator:a8b4e46fd87bbb3cfb655fcd4fb8c2c24"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a900fc56225d0233158eaa9254a3a18f6"><td class="memTemplParams" colspan="2">template&lt;typename D &gt; </td></tr>
<tr class="memitem:a900fc56225d0233158eaa9254a3a18f6"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#a900fc56225d0233158eaa9254a3a18f6">dispatch</a> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node)</td></tr>
<tr class="memdesc:a900fc56225d0233158eaa9254a3a18f6"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function invoke the appropriate handler method for the node's token type..  <a href="#a900fc56225d0233158eaa9254a3a18f6">More...</a><br /></td></tr>
<tr class="separator:a900fc56225d0233158eaa9254a3a18f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr class="memitem:ab9551e2291ee950c20073ab6f70185cf"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab9551e2291ee950c20073ab6f70185cf"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleProgram</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:ab9551e2291ee950c20073ab6f70185cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7a288b5fb6364629e8358ecd3f3abc6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af7a288b5fb6364629e8358ecd3f3abc6"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleConst</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:af7a288b5fb6364629e8358ecd3f3abc6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5f927d32c27e1db11184b5509b60d5f7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5f927d32c27e1db11184b5509b60d5f7"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleChildren</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a5f927d32c27e1db11184b5509b60d5f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6048f2ecfa445593b75adb789603b697"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6048f2ecfa445593b75adb789603b697"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleType</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a6048f2ecfa445593b75adb789603b697"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf12f6600f9bc20c63322370f16fc28f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaf12f6600f9bc20c63322370f16fc28f"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleEnum</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:aaf12f6600f9bc20c63322370f16fc28f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afcd9028cdf33752f19d79c3237af0415"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afcd9028cdf33752f19d79c3237af0415"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleEnumMember</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:afcd9028cdf33752f19d79c3237af0415"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2be03186bb3f90ea7b80bbca8656627d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2be03186bb3f90ea7b80bbca8656627d"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleStruct</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a2be03186bb3f90ea7b80bbca8656627d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac70398c32a6b5a64059fe6719b9b6561"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac70398c32a6b5a64059fe6719b9b6561"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleStructMember</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:ac70398c32a6b5a64059fe6719b9b6561"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e480189a0dfdd3115738a57eb7c98c0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3e480189a0dfdd3115738a57eb7c98c0"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleUnion</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a3e480189a0dfdd3115738a57eb7c98c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ff9202c77108331623c8d47cc35317e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3ff9202c77108331623c8d47cc35317e"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleUnionCase</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a3ff9202c77108331623c8d47cc35317e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46fdabcfe3f3897aacac3aa75b929a17"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a46fdabcfe3f3897aacac3aa75b929a17"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleInterface</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a46fdabcfe3f3897aacac3aa75b929a17"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5798181288f4bb6933eb8a730349000"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac5798181288f4bb6933eb8a730349000"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleFunction</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:ac5798181288f4bb6933eb8a730349000"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e14772f89f1f789a80188fa93a8b090"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4e14772f89f1f789a80188fa93a8b090"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleParam</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a4e14772f89f1f789a80188fa93a8b090"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad86daeb38c283346f065926d1913105e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad86daeb38c283346f065926d1913105e"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleExpr</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:ad86daeb38c283346f065926d1913105e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa3839c5055e2c6ddde949d1cafcefb77"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa3839c5055e2c6ddde949d1cafcefb77"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleBinaryOp</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:aa3839c5055e2c6ddde949d1cafcefb77"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac171b3bafa2b1bbe553e7db67f9c1e14"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac171b3bafa2b1bbe553e7db67f9c1e14"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleUnaryOp</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:ac171b3bafa2b1bbe553e7db67f9c1e14"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ddcaa932133b554b3e702168666f155"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6ddcaa932133b554b3e702168666f155"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleAnnotation</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down">top_down</a>)</td></tr>
<tr class="separator:a6ddcaa932133b554b3e702168666f155"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr class="memitem:a8ead8ef50e773f16173b32aacc60b32f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8ead8ef50e773f16173b32aacc60b32f"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleProgram</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a8ead8ef50e773f16173b32aacc60b32f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2730d29ad6c9776051146fe1ff364da"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa2730d29ad6c9776051146fe1ff364da"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleConst</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:aa2730d29ad6c9776051146fe1ff364da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fbe549b06bd07ea14f12fa444e7e3f8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7fbe549b06bd07ea14f12fa444e7e3f8"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleChildren</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a7fbe549b06bd07ea14f12fa444e7e3f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a803f96c2cc943bfd663423b31b360404"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a803f96c2cc943bfd663423b31b360404"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleType</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a803f96c2cc943bfd663423b31b360404"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab47f190d9ba3d9c18871c8198642b027"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab47f190d9ba3d9c18871c8198642b027"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleEnum</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:ab47f190d9ba3d9c18871c8198642b027"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9c72434d355930777377e6d8bc4b655"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae9c72434d355930777377e6d8bc4b655"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleEnumMember</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:ae9c72434d355930777377e6d8bc4b655"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc8a045f62115cf6cfc727bceb0437c0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abc8a045f62115cf6cfc727bceb0437c0"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleStruct</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:abc8a045f62115cf6cfc727bceb0437c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a69c4a68a72d59271e17010f32f53952a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a69c4a68a72d59271e17010f32f53952a"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleStructMember</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a69c4a68a72d59271e17010f32f53952a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4abd51735d5fba66e8217e5015796a72"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4abd51735d5fba66e8217e5015796a72"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleUnion</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a4abd51735d5fba66e8217e5015796a72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a867523976c755d9324697f1b791d9555"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a867523976c755d9324697f1b791d9555"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleUnionCase</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a867523976c755d9324697f1b791d9555"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21ad880ee87afc60db8add8e521f1b10"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a21ad880ee87afc60db8add8e521f1b10"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleInterface</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a21ad880ee87afc60db8add8e521f1b10"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af46ad066df5c53a2091cc3c790b021e0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af46ad066df5c53a2091cc3c790b021e0"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleFunction</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:af46ad066df5c53a2091cc3c790b021e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a574a603c666837a2ac4a9b9785bc7171"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a574a603c666837a2ac4a9b9785bc7171"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleParam</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:a574a603c666837a2ac4a9b9785bc7171"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa204063251e66f4050adfdfca8250dd1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa204063251e66f4050adfdfca8250dd1"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleExpr</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:aa204063251e66f4050adfdfca8250dd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adfbf66a468ea611eb2cc5ca166fe691e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adfbf66a468ea611eb2cc5ca166fe691e"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleBinaryOp</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:adfbf66a468ea611eb2cc5ca166fe691e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9591df9c26a98346c8f17bcfd715e16"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae9591df9c26a98346c8f17bcfd715e16"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleUnaryOp</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:ae9591df9c26a98346c8f17bcfd715e16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5c263ba6e7609eb2738c530fda11d9c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab5c263ba6e7609eb2738c530fda11d9c"></a>
virtual <a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>handleAnnotation</b> (<a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up">bottom_up</a>)</td></tr>
<tr class="separator:ab5c263ba6e7609eb2738c530fda11d9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:abb18b1e2ae8a82550d0c073927cea0f5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abb18b1e2ae8a82550d0c073927cea0f5"></a>
std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpcgen_1_1_ast_walker.html#abb18b1e2ae8a82550d0c073927cea0f5">m_fileName</a></td></tr>
<tr class="memdesc:abb18b1e2ae8a82550d0c073927cea0f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Stores name of file from which AST was built. <br /></td></tr>
<tr class="separator:abb18b1e2ae8a82550d0c073927cea0f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Performs a depth-first walk of an AST. </p>
<p>Handles these token types:</p><ul>
<li>TOK_PROGRAM</li>
<li>TOK_CONST</li>
<li>TOK_ENUM</li>
<li>TOK_STRUCT</li>
<li>TOK_TYPE</li>
<li>TOK_INTERFACE</li>
<li>TOK_CHILDREN</li>
<li>TOK_ENUM_MEMBER</li>
<li>TOK_STRUCT_MEMBER</li>
<li>TOK_FUNCTION</li>
<li>TOK_PARAM</li>
<li>TOK_EXPR</li>
<li>TOK_ANNOTATION</li>
<li>TOK_LIST</li>
<li>TOK_ARRAY </li>
</ul>
</div><hr/><h2 class="groupheader">Class Documentation</h2>
<a name="structerpcgen_1_1_ast_walker_1_1bottom__up" id="structerpcgen_1_1_ast_walker_1_1bottom__up"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct erpcgen::AstWalker::bottom_up</td>
        </tr>
      </table>
</div><div class="memdoc">
<div class="textblock"><p>Specifier type to select bottom-up handler using ADL. </p>
</div>
</div>
</div>
<a name="structerpcgen_1_1_ast_walker_1_1top__down" id="structerpcgen_1_1_ast_walker_1_1top__down"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct erpcgen::AstWalker::top_down</td>
        </tr>
      </table>
</div><div class="memdoc">
<div class="textblock"><p>Specifier type to select top-down handler using ADL. </p>
</div>
</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ae64501f99560846a44989ca8e02283f6"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">erpcgen::AstWalker::AstWalker </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>inputFile</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>This function initializes object attributes.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inputFile</td><td>Parsed file name. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a900fc56225d0233158eaa9254a3a18f6"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename D &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void AstWalker::dispatch </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td>
          <td class="paramname"><em>node</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function invoke the appropriate handler method for the node's token type.. </p>
<p>This function call handle functions for <a class="el" href="classerpcgen_1_1_ast_node.html" title="Homogeneous AST node class. ">AstNode</a>, which is specified with node token. The template argument <code>D</code> specifies whether the top-down or bottom-up handler should be called, by passing either of the <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1top__down" title="Specifier type to select top-down handler using ADL. ">top_down</a> or <a class="el" href="classerpcgen_1_1_ast_walker.html#structerpcgen_1_1_ast_walker_1_1bottom__up" title="Specifier type to select bottom-up handler using ADL. ">bottom_up</a> typenames.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">node</td><td>Node to handle.</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classerpcgen_1_1internal__error.html" title="Exception class for internal errors. ">internal_error</a></td><td>Thrown if handle function return new node, which want replace given node, but given node is root.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd>void <a class="el" href="classerpcgen_1_1_ast_walker.html#a8b4e46fd87bbb3cfb655fcd4fb8c2c24" title="This function walk the AstNode depth-first and invoke handler methods. ">AstWalker::walk(AstNode * node)</a> </dd></dl>

</div>
</div>
<a class="anchor" id="a8b4e46fd87bbb3cfb655fcd4fb8c2c24"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void AstWalker::walk </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&#160;</td>
          <td class="paramname"><em>node</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function walk the <a class="el" href="classerpcgen_1_1_ast_node.html" title="Homogeneous AST node class. ">AstNode</a> depth-first and invoke handler methods. </p>
<p>This function call for dispatch given node before and after calling walk function for node children.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">node</td><td>The root node of the tree to walk.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd>void <a class="el" href="classerpcgen_1_1_ast_walker.html#a900fc56225d0233158eaa9254a3a18f6" title="This function invoke the appropriate handler method for the node&#39;s token type.. ">AstWalker::dispatch(AstNode * node)</a> </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="_ast_walker_8h_source.html">AstWalker.h</a></li>
<li>AstWalker.cpp</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
